import os
import matplotlib.pyplot as plt
import numpy as np
import scipy.integrate as spi
#ExpFolder = 'C:/DATA/PLUGINS/Python/AgeingSimulationVerticalAndHorizontalTransmission/'
ExperimentFolder='C:/DATA/Ageing/Caviar/FIG3_DETER/'
outfile=open(ExperimentFolder +"AnFIG3_B_range_big_btnk_25_5DEG_control.txt", 'w')

vX = 0
v0 = np.zeros(2, dtype=float)
Btlnck  = 25.0
v0[0]  = 0.0
v0[1]  = Btlnck
A = 200.0
B = 0.04
beta= 0.04

##/////////////////////
BetaCoeff = 1.0 #3.2744
##/////////////////////

N = 5000.0
P = 0.0
number_of_datapoints = 10000
t = np.linspace(0, 5000, number_of_datapoints)

def f(v, t0, ):

    global A, B, N, P, beta
    dN = np.zeros(2, dtype=float)

    TotalPopulation = v[0] + v[1]

    dN[0] = v[0] * ( - 1.0 / float(A)) - v[0] * v[1] * beta / N + B * (v[1] * (1.0 - P) + v[0]) * (N**5 - TotalPopulation**5) / N**5
    dN[1] = v[1] * ( - 1.0 / float(A)) + v[0] * v[1] * beta / N

    return dN #np.r_[Ssl_new, Sll_new, Isl_new, Ill_new]

def MainSim(Age):
    global A, vX, number_of_datapoints
    A = Age
    vX = spi.odeint(f, v0, t)

    for i in range(number_of_datapoints):
        if vX[i][1] < 1.0:
            return 1

    return 0

def FindBorderAge():

    UpperAgeLimit = 10000.0
    LowerAgeLimit = 1.0 #/ B + 1#10.0
    GoOn = True
    while GoOn==True:

        if (UpperAgeLimit-LowerAgeLimit < 1):
            #print HT, (LowerAgeLimit + UpperAgeLimit) / 2
            return (LowerAgeLimit+UpperAgeLimit) / 2.0

            #LowerVal = MainSim(LowerAgeLimit)
            #outfile.write(str(HT) + '\t' + str((LowerAgeLimit + UpperAgeLimit) / 2) + '\n')
        else:
            UpperVal = MainSim(UpperAgeLimit)
            MidVal = MainSim((UpperAgeLimit+LowerAgeLimit) / 2)

            if MidVal==UpperVal:
                UpperAgeLimit = (LowerAgeLimit + UpperAgeLimit) / 2
            else:
                LowerAgeLimit = (LowerAgeLimit + UpperAgeLimit) / 2
        #print(LowerAgeLimit , UpperAgeLimit)

        #print MainSim(D, B, N, ParEffect, 100, HT, Hizero)

#print MainSim(B, N, ParEffect, 90.0, HT, Hizero)
#AgeOfDeath = 100.0

out=''

#B = 0.05
#beta = 0.013
#B=0.02
#beta=0.03
#N=5000
#v0[0]=0.0
#v0[1]=25.0
#P = 0.0

#print MainSim(90)

#fig, ax = plt.subplots(1, 1, figsize=(8, 4))

#ax.plot(t, vX[:,0], '-', c = 'y', alpha=1)
#ax.plot(t, vX[:,1], '-', c = 'r', alpha=1)
#plt.show()

#exit()
#Brange = [0.01, 0.02, 0.03, 0.05]
Brange = [0.01, 0.02, 0.03, 0.04, 0.05] #, 0.05, 0.07]#, 10000, 20000, 50000, 100000, 150000, 200000, 250000]
#for BNS in range(2,202, 10):
for B in Brange:
    out+="\tbottleneck_B=" + str(float(B)) + '\t'
    out += "Fig1r_B=" + str(float(B)) + '\t'

out += "P=" + str(P) + '\t' + "v0=" + str(v0[1]) + '\t' + "N=" + str(N)
outfile.write(out + '\n')

for HTindex in range(1, 1001, 100):

    beta = float(HTindex) / 10000.0 * BetaCoeff

    out = ""# +str(beta) + '\t' #+ str(float(HTindex) / 10000.0) + '\t'

    for B in Brange:
        v0[0] = 0.0
        out += str(beta) + '\t' + str(FindBorderAge())+'\t'
        v0[0] = N  - Btlnck
        out += str(FindBorderAge()) + '\t'

    outfile.write(out + '\n')
    print out

outfile.close()

exit()

B = 0.5
MainSim(1.0)

fig, ax = plt.subplots(1, 1, figsize=(8, 4))

ax.plot(t, vX[:,0], '-', c = 'y', alpha=1)
ax.plot(t, vX[:,1], '-', c = 'r', alpha=1)
plt.show()
