import matplotlib.pyplot as plt
import numpy as np
import math
import random
#import cProfile
#import re
import sys
import os

param_modifier = np.zeros(10, dtype=float)
Suffix = "INFP_NP"

DisplayWindow = 0
if DisplayWindow==0:
    REPL = int(sys.argv[1])
    SET_NUMBER = int(sys.argv[2])
    #BETA_PARAM = float(int(sys.argv[3])) / 1000.0
    INFP_PARAM = float(int(sys.argv[3])) / 100.0
    NP_PARAM = int(sys.argv[4])
    #AREA_MODIFIER = float(int(sys.argv[3])) / 100

    ExpFolder = '/andino/hpse1/home/plidsky/Ageing/Caviar/Cav4_'+ Suffix + '/'
else:
    REPL = 1#int(sys.argv[1])
    SET_NUMBER = 1#int(sys.argv[2])
    #AREA_MODIFIER = 1.0#float(int(sys.argv[3]))
    INFP_PARAM = 0.4 #float(int(sys.argv[3])) / 100.0
    NP_PARAM = 16 #int(sys.argv[4])

    ExpFolder = "C:/DATA/Ageing/Caviar/Cav4_INFP_NP/"


TimelineFileName  = ExpFolder + "cav4_" + Suffix + "_" + str(SET_NUMBER)+ "_replicate_" + str(REPL) +".txt"
TimelineFile = open(TimelineFileName, 'w')

filenameX = ExpFolder + "SummaryCav4_"+ Suffix + ".txt"

if os.path.isfile(filenameX) == False:
    inputfile = open(filenameX, 'w')
    inputfile.write('AreaModif\tSetNo\tReplica\tOUTCOME\tTotalTime\t0-Repulsion\t1-BirthRate\t2-MaxAgeShort\tMaxAgeLong\t3-Infectivity\t4-InfectionPenalty\tDensityOfSLAt300\tTimeOfLLPeaking\tPEAKNumberOfSL\tPEAKNumberOfLL\tPEAK_inf_proportionSL\tPEAK_inf_proportionLL\tFINTime\tFINTotalNumberOfAnimals\tFINNumberOfSL\tFINSLInfected\tFINNumberOfLL\tFINLLInfected\tFINSL_inf_proportion\tFINLL_inf_proportion\n')
    inputfile.close()

DensityOfSLAt300 = 0
TimeOfLLPeaking = 0
PEAKNumberOfSL = 0
PEAKNumberOfLL = 0
PEAK_inf_proportionSL = 0
PEAK_inf_proportionLL = 0

random.seed()
plt.ion()

Timepoints = 100000
CurrentTime = 0

DirectionOfInfection = ([0, 0], [0, 0])

#Host population
MaxPopSize = 500000
PopSize = 1340 * 4
#MapSize = 10000.0
MapXSize = 10000.0
MapYSize = 10000.0

MaxDistanceFromCenter = math.sqrt((MapXSize /2)**2 + (MapYSize /2)**2)

NumberOfSubdivisions = 100.0
MapConv = math.sqrt(MapXSize * MapYSize) / NumberOfSubdivisions
SubdivXSize = MapXSize / MapConv + 1
SubdivYSize = MapYSize / MapConv + 1

NoOfSLAnimals = np.zeros(5000, dtype=int)
NoOfLLAnimals = np.zeros(5000, dtype=int)
NoOfInfections = np.zeros(5000, dtype=int)

########
#WAverageDistance = 0.0
#WNumberOfInteractions = 0.0
#WGlobalNumberOfInteractionsPerHost = 0.0

#Host movement
#TurningProbability = 0.01
MaxSpeed = 10.0
FrictionCoeff = 0.0005

MaxRadius = 400.0
MaxRadiusSq = MaxRadius**2.0

InfectionRadius = 200.0
InfectionRadiusSq = InfectionRadius**2.0

Range = InfectionRadius / 2.0 #This is about area each individual takes
RangeSq = Range**2.0
MaxArea = math.pi * RangeSq #/ 2.0
MaxArea_old = math.pi * RangeSq / 2.0
Repulsion = 30000 # * param_modifier[0] ################0
AREA_MODIFIER = 1.0 #float(int(sys.argv[3])) / 100
ShufflingProbability = 0
#RepulsionWall = 1000

BirthRate = 0.04 # + 0.04  * param_modifier[1] #################1
ReplicationFreq = 100.0 / BirthRate
MaxAgeShort = 90 #+ 60  * param_modifier[2] #################2
MaxAgeLong = 180
#Virus
Infectivity = 0.03 #0.040 # * param_modifier[3] ##############3
#InfectionPenalty = 0.90#  + 0.2 * param_modifier[4] ##########4
InfectionPenalty = INFP_PARAM
numberOfPathogens = NP_PARAM

MaxAnimalsInSubdivision = 10000

############################################################

TimelineFile.write('SetNumber\tReplica\t0-Repulsion\tSufflingProbability\tMaxSpeed\tFrictionCoeff\tMaxRadius\tInfectionRadius\t1-BirthRate\t2-MaxAgeShort\tMaxAgeLong\t3-Infectivity\t4-InfectionPenalty\n')
Output = str(SET_NUMBER) + '\t' + str(REPL) + '\t' + str(Repulsion) +'\t'+ str(ShufflingProbability) +'\t'+ str(MaxSpeed) + '\t' + str(FrictionCoeff) + '\t' + str(MaxRadius) + '\t' + str(InfectionRadius) + '\t' + str(BirthRate) + '\t' + str(MaxAgeShort) + '\t' + str(MaxAgeLong) + '\t' + str(Infectivity) + '\t' + str(InfectionPenalty) + '\n'
TimelineFile.write(Output)

SLSummaryLabel = 'SLUninfected\t'
LLSummaryLabel = 'LLUninfected\t'
for n in range(numberOfPathogens):
    SLSummaryLabel +='SL_Infected_with_' + str(n) +'\t'
    LLSummaryLabel +='LL_Infected_with_' + str(n) +'\t'
Output = ""
for i in range(100):
    Output = Output + "DistanceBin_" +str(i+1) + '\t'
TimelineFile.write('Time\tTotalNumberOfAnimals\t'+ SLSummaryLabel + LLSummaryLabel +  'SL_averageArea\tLL_averageArea\tinf_SL->SL\tinf_SL->LL\tinf_LL->SL\tinf_LL->LL\t' + Output +'\n')
TimelineFile.close()
TimelineFile = open(TimelineFileName, 'a')
############################################################


Animals = np.zeros(PopSize)
Age = np.zeros(PopSize)
ReplicationScore = np.zeros(PopSize)
Fitness = np.zeros(PopSize)
Fitness_old = np.zeros(PopSize)
#AreaBelonging = np.zeros(PopSize)
X = np.zeros(PopSize)
Y = np.zeros(PopSize)
Area = np.zeros(PopSize)
residueX = np.zeros(PopSize)
residueY = np.zeros(PopSize)
speedX = np.zeros(PopSize)
speedY = np.zeros(PopSize)
MaxAge = np.zeros(PopSize)
Feature = np.zeros(PopSize, dtype=int) #ID
#InfectionStatus = np.zeros(PopSize, dtype=int) #
InfectionID = np.zeros(PopSize, dtype=int) #ID
InfectionPOT = np.zeros(PopSize, dtype=float) #POT
LMX=np.zeros(PopSize, dtype=int)
LMY=np.zeros(PopSize, dtype=int)
InfectionStatus = np.zeros((PopSize, numberOfPathogens), dtype=int) #
#Shapes = [[Segment for x in xrange(12)] for y in xrange(MaxPopSize)]

ShuffledIndexes = np.zeros(PopSize)
SummOfAllInteraction = np.zeros(PopSize)
SummOfAllInteraction_old = np.zeros(PopSize)
Area_old = np.zeros(PopSize)

VirusGenotypes = np.zeros(100, dtype=int)

#IsOnApple = np.zeros(PopSize, dtype=int)
#TargrgetedToApple = np.zeros(PopSize, dtype=int)
#DistanceToTargetedToApple = np.zeros(PopSize) + 10000000000000
#RelationToApples = np.zeros(PopSize, dtype=int)

LargeMap = np.zeros((int(SubdivXSize+1), int(SubdivYSize+1), MaxAnimalsInSubdivision), dtype=int)
LargeMapNumOfAnimals = np.zeros((int(SubdivXSize+1 ), int(SubdivYSize +1)))

#Mutations
#MutationProbability = 0.0001
#NumberOfStrains = 2


def Start():
    #for index in range(1, 3):
    #PopSize = 1000
    #
    #for index in range(1, PopSize/2):
    for index in range(1, PopSize):
        Animals[index] = 1
        Fitness[index] = 100.0
        ReplicationScore[index] = random.random() * ReplicationFreq
        #AreaBelonging[index] = math.pi * Range**2 / 2
        #X[index] = 5000
        #Y[index] = 5000
        X[index] = random.random() * float(MapXSize)
        Y[index] = random.random() * float(MapYSize)
        speedX[index] = MaxSpeed - random.random() * MaxSpeed * 2.0
        speedY[index] = MaxSpeed - random.random() * MaxSpeed * 2.0
        MaxAge[index] = MaxAgeShort
        Age[index] = MaxAge[index] * random.random()
        for j in range(numberOfPathogens):
            InfectionStatus[index][j] = 0

        InfectionPOT[index] = 0
        InfectionID[index] = 0
        Area[index] = 0
        AddAnimalToMatrix(index)
    #X[1] = 5001
    #X[2] = 5000
    #Y[1] = 5001
    #Y[2] = 5000
    #return
    #long lifespans

def MaintainThePathogen():
    global InfectionStatus
    for k in range(numberOfPathogens):
        N = (InfectionStatus[:,k]==1).sum()
        if N < 5:
            for i in range(5-N):
                index =  int(random.random() * PopSize-2)
                InfectionStatus[index+1][k]=1

def SeedTheExpriment():
    Adistance = 3.0
    global MapXSize, MapYSize, X, Y, InfectionStatus

    # Feature = np.floor(np.sqrr((X - MapXSize/2)**2 + (Y - MapYSize / 2)**2))

    for index in range(1, PopSize):
        Feature[index] = int(math.sqrt((X[index] - MapXSize / 2.0) ** 2.0 + (Y[index] - MapYSize / 2.0) ** 2.0))

        if (X[index] - MapXSize / 2.0) ** 2.0 + (Y[index] - MapYSize / 2.0) ** 2.0 < 50000:
            MaxAge[index] = MaxAgeLong
            Feature[index] = 0

        # infections
    #infections
def SeedPatogen(AmountOfPathogens):
    global InfectionStatus, X, Y
    #for i in range (AmountOfPathogens):
    #    index = int(random.random() * PopSize)
    #    InfectionStatus[index] = 1
    Adistance = 3.0
    for index in range(1, PopSize):
        #Feature[index] = int(math.sqrt((X[index] - MapXSize / 2.0) ** 2.0 + (Y[index] - MapYSize / 2.0) ** 2.0))

        # infections
        Iter = numberOfPathogens

        if Iter < 4:
            Iter = 4

        for P_index in range(4):
            if (X[index] - MapXSize / Adistance) ** 2.0 + (Y[index] - MapYSize / Adistance) ** 2.0 < 50000.0:
                for w in range(0, Iter, 4):
                    w1 = w
                    if w1 >= numberOfPathogens:
                        w1 = w1 - numberOfPathogens
                    InfectionStatus[index][w1] = 1
                    # InfectionStatus[index][1] = 1

            if (X[index] - MapXSize * (1.0 - 1.0 / Adistance)) ** 2.0 + (
                        Y[index] - MapYSize / Adistance) ** 2.0 < 50000.0:
                for w in range(1, Iter, 4):
                    w1 = w
                    if w1 >= numberOfPathogens:
                        w1 = w1 - numberOfPathogens
                    InfectionStatus[index][w1] = 1
                    # InfectionStatus[index][0] = 1

            if (X[index] - MapXSize / Adistance) ** 2.0 + (
                        Y[index] - MapYSize * (1.0 - 1.0 / Adistance)) ** 2.0 < 50000.0:
                for w in range(2, Iter, 4):
                    w1 = w
                    if w1 >= numberOfPathogens:
                        w1 = w1 - numberOfPathogens
                    InfectionStatus[index][w1] = 1
            # InfectionStatus[index][1] = 1

            if (X[index] - MapXSize * (1.0 - 1.0 / Adistance)) ** 2.0 + (
                        Y[index] - MapYSize * (1.0 - 1.0 / Adistance)) ** 2.0 < 50000.0:
                for w in range(3, Iter, 4):
                    w1 = w
                    if w1 >= numberOfPathogens:
                        w1 = w1 - numberOfPathogens
                    InfectionStatus[index][w1] = 1
                    # InfectionStatus[index][0] = 1
                    # print "start done"

def ShuffleIndexes():
    global ShuffledIndexes
    ShuffledIndexes = np.zeros(PopSize)
    for i in range(1, PopSize):
        ShuffledIndexes[i] = int(i)
    random.shuffle(ShuffledIndexes)
    ShuffledIndexes = np.append([0], ShuffledIndexes)

def MovementAndInfection():
    global SummOfAllInteraction, SummOfAllInteraction_old, WAverageDistance, WNumberOfInteractions, WGlobalNumberOfInteractionsPerHost, SubdivXSize, MaxRadiusSq
    ShuffleIndexes()
    #Calculate range of interactions
    wrange = int(round(MaxRadius / MapConv)) + 1

    SummOfAllInteraction = np.zeros(PopSize)
    SummOfAllInteraction_old= np.zeros(PopSize)

    ######
    #WAverageDistance = 0.0
    #WNumberOfInteractions = 0.0
    #WGlobalNumberOfInteractionsPerHost = 0.0
    #--------------------
    for i in range(1, PopSize):
        #Calculate working box
        top = LMY[i] + wrange
        bottom = LMY[i] - wrange
        left = LMX[i] - wrange
        right = LMX[i] + wrange

        ####
        #WNumberOfInteractionsPerHost = 0

        #if top >= SubdivYSize: top = int(SubdivYSize-1)
        #if bottom < 0:
        #    bottom = 0

        NewSpeedX = 0
        NewSpeedY = 0

        for lxindex in range(left, right+1):
            if lxindex < 0:
                ExcessX = SubdivXSize + 1
                RelationToBorderX = -1
            elif lxindex > SubdivXSize:
                ExcessX = - SubdivXSize
                RelationToBorderX = 1
                #Excess = -lxindex
            else:
                ExcessX = 0
                RelationToBorderX = 0

            for lyindex in range(bottom, top + 1):
                if lyindex < 0:
                    ExcessY = SubdivYSize + 1
                    RelationToBorderY = -1
                elif lyindex > SubdivYSize:
                    ExcessY = - SubdivYSize
                    RelationToBorderY = 1
                    # Excess = -lxindex
                else:
                    ExcessY = 0
                    RelationToBorderY = 0

                index = 1
                while True:
                    a = LargeMap[lxindex + int(ExcessX)][lyindex+ int(ExcessY)][index]
                    if a == 0: break

                    distanceSq = float((X[a]+ RelationToBorderX * MapXSize - X[i])**2 + (Y[a]+ RelationToBorderY * MapYSize - Y[i])**2)

                    if i!=a:
                        InfectionPOT[i] = math.sqrt(distanceSq)
                    #distanceSq = distance**2.0
                    distanceCube = distanceSq**1.5# math.sqrt(distanceSq)
                    #print distanceSq
                    if (distanceSq < RangeSq*4):
                        ##############
                        #WAverageDistance += math.sqrt(distanceSq)
                        #WNumberOfInteractions+=1
                        #WNumberOfInteractionsPerHost+=1

                        AngleAlpha = 2.0 * math.acos(math.sqrt(distanceSq / RangeSq/ 4.0))
                        #if i==1:
                        #    print str(i),'->',str(a),'\t', "d=",'\t', math.sqrt(distanceSq),'\t', "alpha=",'\t', AngleAlpha
                        #print AngleAlpha, AngleAlpha - math.sin(AngleAlpha)
                        if i!=a:
                            SummOfAllInteraction[i] += AngleAlpha - math.sin(AngleAlpha)
                        SummOfAllInteraction_old[i] += AngleAlpha/2.0 - math.sin(AngleAlpha/2.0)
                        #print AngleAlpha - math.sin(AngleAlpha)

                    if (distanceCube==0):
                        distanceCube = 1.0
                    NewSpeedX += Repulsion * (X[i]-(X[a] + RelationToBorderX * MapXSize)) / (distanceCube)
                    NewSpeedY += Repulsion * (Y[i]-(Y[a] + RelationToBorderY * MapYSize)) / (distanceCube)

                    for k in range(numberOfPathogens):
                        if InfectionStatus[i][k] > InfectionStatus[a][k] and random.random() < Infectivity * (InfectionRadiusSq - distanceSq) /(InfectionRadiusSq):
                            InfectionStatus[a][k] = 1

                            index1 = 0
                            index2 = 0

                            if (MaxAge[i] == MaxAgeLong): index1 = 1
                            if (MaxAge[a] == MaxAgeLong): index2 = 1

                            DirectionOfInfection[index1][index2] += 1

                        #if distanceSq < Range * Range and random.random() < Infectivity * (Range*Range - distanceSq) /(Range*Range) * AssymetryBenignAcute[InfectionStatus[i]]:
                        #    InfectionStatus[a] = 1
                        #    InfectionPOT[a] = InfectionPOT[i]
                        #    InfectionID[a] = InfectionID[i]

                    index+=1

        speedX[i] += NewSpeedX #+ RepulsionWall * (1 / X[i] - 1/(MapXSize - X[i]))
        speedY[i] += NewSpeedY #+ RepulsionWall * (1 / Y[i] - 1/(MapYSize - Y[i]))

        #WGlobalNumberOfInteractionsPerHost += WNumberOfInteractionsPerHost
        #FrictionCoeff = 0.00000002
        #speedX[i] += - speedX[i]**3 * FrictionCoeff
        #speedY[i] += - speedY[i]**3 * FrictionCoeff

        #if (X[i]**2.0<RangeSq):
        #    AngleAlpha = math.acos(math.sqrt(1.0 - X[i]**2.0 / RangeSq))
        #    SummOfAllInteraction[i] += AngleAlpha - math.sin(AngleAlpha)
        #if (Y[i]**2.0<RangeSq):
        #    AngleAlpha = math.acos(math.sqrt(1.0 - Y[i]**2.0 / RangeSq))
        #    SummOfAllInteraction[i] += AngleAlpha - math.sin(AngleAlpha)
        #if ((MapXSize-X[i])**2.0<RangeSq):
        #    AngleAlpha = math.acos(math.sqrt(1.0 - (MapXSize-X[i])**2.0 / RangeSq))
        #    SummOfAllInteraction[i] += AngleAlpha - math.sin(AngleAlpha)
        #if ((MapYSize-Y[i])**2.0<RangeSq):
        #    AngleAlpha = math.acos(math.sqrt(1.0 - (MapYSize-Y[i])**2.0 / RangeSq))
        #    SummOfAllInteraction[i] += AngleAlpha - math.sin(AngleAlpha)

        TotalSpeed = (speedX[i]*speedX[i] + speedY[i]*speedY[i]) / (MaxSpeed * MaxSpeed)
        if TotalSpeed > 1:
            speedX[i] = speedX[i] / math.sqrt(TotalSpeed)
            speedY[i] = speedY[i] / math.sqrt(TotalSpeed)

    for j in range(1, PopSize):
        index = int(ShuffledIndexes[j])
        #Movement itself
        X[index] += speedX[index]
        Y[index] += speedY[index]

        if X[index] > MapXSize:
            X[index] = X[index] - MapXSize
        elif X[index] < 0:
            X[index] = MapXSize + X[index]

        if Y[index] > MapYSize:
            Y[index] = Y[index] - MapYSize
        elif Y[index] < 0:
            Y[index] = MapYSize + Y[index]


        ##########
        #if WNumberOfInteractions > 0:
        #    WAverageDistance = WAverageDistance / WNumberOfInteractions


            #if random.random() < TurningProbability * turncoeff:
        #    speedX[index] = MaxSpeed - random.random() * MaxSpeed * 2.0
        #    speedY[index] = MaxSpeed - random.random() * MaxSpeed * 2.0

def AddAnimal(newX, newY, MaxAgeLimit, F):
    global Area, Area_old, Feature, Fitness_old, Radius,MaxAge, Animals, ReplicationScore, Fitness,AreaBelonging, X, Y, residueX, residueY, speedX, speedY, PopSize, Age, InfectionStatus, LMX, LMY, DistanceToTargetedToApple, RelationToApples, InfectionPOT, InfectionID
    if PopSize > MaxPopSize: return
    Animals = np.append(Animals,[1])
    ReplicationScore = np.append(ReplicationScore, [0])
    Fitness = np.append(Fitness, [100])
    Fitness_old = np.append(Fitness_old, [100])

    X = np.append(X, [newX])
    Y = np.append(Y, [newY])
    residueX = np.append(residueX, [0])
    residueY = np.append(residueY, [0])
    speedX = np.append(speedX, [MaxSpeed - random.random() * MaxSpeed * 2.0])
    speedY = np.append(speedY, [MaxSpeed - random.random() * MaxSpeed * 2.0])
    #AreaBelonging = np.append(AreaBelonging, [math.pi * Range ** 2 / 2])
    Age = np.append(Age, [0])
    MaxAge = np.append(MaxAge, [MaxAgeLimit])
    newPat = np.zeros(numberOfPathogens)
    InfectionStatus = np.append(InfectionStatus, [newPat], axis=0)
    LMX = np.append(LMX,[0])
    LMY = np.append(LMY, [0])
    InfectionPOT = np.append(InfectionPOT, [0])
    InfectionID = np.append(InfectionID, [0])
    Feature = np.append(Feature, [F])
    #IsOnApple = np.append(IsOnApple, [0])
    #TargrgetedToApple = np.append(TargrgetedToApple, [0])
    #DistanceToTargetedToApple = np.append(DistanceToTargetedToApple, [10000000000000])
    #RelationToApples = np.append(RelationToApples, [0])
    Area = np.append(Area, [math.pi * RangeSq / 2])
    Area_old= np.append(Area_old, [math.pi * RangeSq / 2])

    AddAnimalToMatrix(PopSize)
    PopSize+=1

def DeleteAnimal(indexToDel):
    global Area, Area_old, Radius, Feature, Animals, ReplicationScore, Fitness_old, Fitness,AreaBelonging, X, Y, residueX, residueY, speedX, speedY, PopSize, Age, MaxAge, InfectionStatus, LMX, LMY, DistanceToTargetedToApple, RelationToApples, InfectionPOT, InfectionID
    #DeleteAnimalFromMatrix(indexToDel)

    Animals = np.delete(Animals, indexToDel)
    ReplicationScore = np.delete(ReplicationScore, indexToDel)
    Fitness = np.delete(Fitness, indexToDel)
    Fitness_old = np.delete(Fitness_old, indexToDel)
    X = np.delete(X, indexToDel)
    Y = np.delete(Y, indexToDel)
    residueX = np.delete(residueX, indexToDel)
    residueY = np.delete(residueY, indexToDel)
    speedX = np.delete(speedX, indexToDel)
    speedY = np.delete(speedY, indexToDel)
    Age = np.delete(Age, indexToDel)
    MaxAge = np.delete(MaxAge, indexToDel)
    InfectionStatus = np.delete(InfectionStatus, indexToDel, axis=0)
    InfectionPOT = np.delete(InfectionPOT, indexToDel)
    InfectionID = np.delete(InfectionID, indexToDel)
    Feature = np.delete(Feature, indexToDel)
    LMX = np.delete(LMX, indexToDel)
    LMY = np.delete(LMY, indexToDel)
    #RelationToApples = np.delete(RelationToApples, indexToDel)
    #DistanceToTargetedToApple = np.delete(DistanceToTargetedToApple, indexToDel)
    Area = np.delete(Area, indexToDel)
    Area_old = np.delete(Area_old, indexToDel)
    PopSize -= 1

def Replication():
    global X, Y
    ShuffleIndexes()
    for j in range(1, PopSize):
        index  = int(ShuffledIndexes[j])
        ReplicationScore[index] += Fitness[index]
        if (ReplicationScore[index] > ReplicationFreq):
            ReplicationScore[index] = 0
            deltaX = 1.0 - 2.0 * random.random()
            deltaY = random.choice([-1, 1]) * math.sqrt(1 - deltaX * deltaX)
            AddAnimal(X[index] + deltaX, Y[index] + deltaY, MaxAge[index], Feature[index])
            X[index] = X[index] - deltaX
            Y[index] = Y[index] - deltaY

def Death():
    global Animals
    index = 1
    while index < PopSize:
        Age[index] += 1
        if Age[index] > MaxAge[index]:
            Animals[index] = 0
            DeleteAnimal(index)
        else:
            index+=1

def AddAnimalToMatrix(i):
    global LargeMap, LargeMapNumOfAnimals, LMX, LMY
    #print LargeMapNumOfAnimals.size
    LMX[i]=int(round(X[i]/MapConv))
    LMY[i]=int(round(Y[i]/MapConv))
    LargeMapNumOfAnimals[LMX[i]][LMY[i]] +=1
    #Size =
    LargeMap[LMX[i]][LMY[i]][int(LargeMapNumOfAnimals[LMX[i]][LMY[i]])] = i

def CalculateSpeed():
    x=0

def RenewMatrix():
    global LargeMap, LargeMapNumOfAnimals
    LargeMap = np.zeros((int(SubdivXSize + 1), int(SubdivYSize + 1), MaxAnimalsInSubdivision), dtype=int)
    LargeMapNumOfAnimals = np.zeros((int(SubdivXSize + 1), int(SubdivYSize + 1)))
    #LargeMap = np.zeros((int(NumberOfSubdivisions + 1), int(NumberOfSubdivisions + 1), MaxAnimalsInSubdivision), dtype=int)
    #LargeMapNumOfAnimals = np.zeros((int(NumberOfSubdivisions + 1), int(NumberOfSubdivisions + 1)))

    for i in range(1, PopSize):
        AddAnimalToMatrix(i)

def CalculateArea():
    global Fitness, Area, RangeSq, MaxArea
    for i in range(1, PopSize):
        Area[i] = (math.pi - SummOfAllInteraction[i]/2) * RangeSq #/ 2.0
        Area_old[i] = (math.pi - SummOfAllInteraction_old[i]) * RangeSq / 2.0
        #print i, '\t', "Area=", Area[i]
        if Area[i]<0: Area[i]=0

        Fitness[i] = 100 * (1 - InfectionPenalty * InfectionStatus[i][:].sum()) * (1.0 - AREA_MODIFIER * (MaxArea- Area[i]) / MaxArea)
        #Fitness_old[i] = 100 * (1 - InfectionPenalty * InfectionStatus[i]) * (Area_old[i] - (MaxArea_old) / 2.0) / (MaxArea_old) * 2.0
        if Fitness[i]<0: Fitness[i]=0
        #if Fitness_old[i] < 0: Fitness_old[i] = 0
    #print "DISTANCE=", '\t', InfectionPOT[i],'\t',"SAI=", '\t', SummOfAllInteraction[1],'\t',"AREA=",'\t',Area[1],'\t',"FITNESS=",'\t',Fitness[1]
    #A = Fitness - Fitness_old
    #print A.mean(), A.std()
    #print "SuumOfAllInteractions=" + str(np.sum(SummOfAllInteraction)/PopSize)
    #print PopSize, np.sum(Area)/ PopSize, np.sum(SummOfAllInteraction)/PopSize

def WriteTimelineFile():
    ShortLivedInfected = np.zeros(numberOfPathogens)
    LongLivedInfected = np.zeros(numberOfPathogens)
    global DensityOfSLAt300, TimeOfLLPeaking, PEAKNumberOfSL, PEAKNumberOfLL, PEAK_inf_proportionSL, PEAK_inf_proportionLL, Area, Feature, DirectionOfInfection

    Distances = np.zeros(100)

    AreaSL = 0.0
    AreaLL = 0.0
    for i in range(1, PopSize):

        Distances[int(100 * Feature[i] / MaxDistanceFromCenter)] += 1

        if (MaxAge[i] == MaxAgeLong):
            AreaLL += Area[i]
        else:
            AreaSL += Area[i]

        if (InfectionStatus[i,:].sum() > 0):
            if (MaxAge[i] == MaxAgeLong):
                LongLivedInfected[int(InfectionStatus[i][:].sum())-1] += 1
            else:
                ShortLivedInfected[int(InfectionStatus[i,:].sum())-1] += 1

    ShortTotal = (MaxAge == MaxAgeShort).sum()
    LongTotal = (MaxAge == MaxAgeLong).sum()

    if ShortTotal >0:
        AreaSL = AreaSL / ShortTotal
    else:
        AreaSL = 0

    if LongTotal > 0:
        AreaLL = AreaLL / LongTotal
    else:
        AreaLL = 0

    OutDistances = ""
    for i in range(100):
        OutDistances += str(int(Distances[i])) + '\t'

    ShortLivedSummary  = str(ShortTotal) + '\t'
    LongLivedSummary = str(LongTotal) + '\t'
    for n in range(numberOfPathogens):
        ShortLivedSummary += str(ShortLivedInfected[n]) + '\t'
        LongLivedSummary += str(LongLivedInfected[n]) + '\t'
    #Output = str(CurrentTime) + '\t' + str(PopSize - 1) + '\t ' + str(ShortTotal) + '\t' + str(ShortLivedInfected) + '\t' + str(
    #LongTotal) + '\t' + str(LongLivedInfected) + '\t' + str(ShortIPercent) + '\t' + str(LongIPercent) + '\t' +str(((MaxAge==MaxAgeShort) * Area).mean()) + '\t' +str(((MaxAge==MaxAgeLong) * Area).mean()) +'\t' + str(DirectionOfInfection[0][0])+'\t' + str(DirectionOfInfection[0][1])+'\t' + str(DirectionOfInfection[1][0])+'\t' + str(DirectionOfInfection[1][1]) + '\t' + OutDistances + '\n'
    Output = str(CurrentTime) + '\t' + str(PopSize - 1) + '\t ' + ShortLivedSummary + LongLivedSummary + str(AreaSL) + '\t' +str(AreaLL) +'\t' + str(DirectionOfInfection[0][0])+'\t' + str(DirectionOfInfection[0][1])+'\t' + str(DirectionOfInfection[1][0])+'\t' + str(DirectionOfInfection[1][1]) + '\t' + OutDistances

    # ,'\t', float((InfectionStatus == 1).sum()+(InfectionStatus == 2).sum()) / (PopSize), '\t', LargeMapNumOfAnimals.max() #LargeMapNumOfAnimals.max()
    if PEAKNumberOfLL < LongTotal:
        TimeOfLLPeaking = CurrentTime
        PEAKNumberOfSL = ShortTotal
        PEAKNumberOfLL = LongTotal
        PEAK_inf_proportionSL = (ShortLivedInfected[0] + ShortLivedInfected[1]) / (1  + ShortTotal)
        PEAK_inf_proportionLL = (LongLivedInfected[0] + LongLivedInfected[1]) / (1  + LongTotal)

    if (CurrentTime == 300):
        DensityOfSLAt300 = ShortTotal

    if DisplayWindow==1:
        print Output
        #print Area
    TimelineFile.write(Output + '\n')

    DirectionOfInfection = ([0, 0], [0, 0])

    return Output

class DynamicUpdate():
    #Suppose we know the x range
    min_x = 0
    max_x = MapXSize
    min_y = 0
    max_y = MapYSize
    tPlt = 0
    axes = 0
    global ColorMapUsed, HistogrammUpperLimit, HistColor, binning
    ColorMapUsed = 'summer'
    binning = 1
    HistogrammUpperLimit = 135 #int(MaxAgeShort)

    HistColor = np.zeros((HistogrammUpperLimit, 4))


    def on_launch(self):
        #Set up plot
        self.figure, self.ax = plt.subplots()
        #self.figure, self.ax.plot(figsize = (4000,250))
        self.linesi0, = self.ax.plot([], [], 'o', color='g', markersize=6.0)
        self.linesi1, = self.ax.plot([], [], 'o', color='b', markersize=6.0)
        self.linesi10, = self.ax.plot([], [], 'o', color='brown', markersize=6.0)
        self.linesi2, = self.ax.plot([], [], 'o', color='black', markersize=6.0)

        self.lines, = self.ax.plot([],[], 'o', color = 'y', markersize=3.0)
        self.lines1, = self.ax.plot([], [], 'o', color='tomato', markersize=3.0)


        #self.lines2, self.ax.scatter([], [], marker='o', c='b')
        #self.linesapples, = self.ax.plot([], [], '.', color='y', lw = 500)
        #self.linesBirth, = self.ax.plot([], [], '.', color='b')
        #Autoscale on unknown axis and known lims on the other
        self.ax.set_autoscaley_on(True)
        self.ax.set_xlim(self.min_x, self.max_x)
        self.ax.set_ylim(self.min_y, self.max_y)
        #Other stuff
        self.ax.grid()


    def on_running(self, xdata, ydata, xdata1, ydata1, xdatai0, ydatai0, xdatai1, ydatai1 , xdatai10, ydatai10, xdatai2, ydatai2):
        #Update data (with the new _and_ the old points)
        #self.ax.plot(color='r')
        #self.figure, self.ax = plt.subplots()

        #self.lines , =self.ax.plot([],[],'.', color='r')

        #self.ax.plot([],[],color='r')
        self.linesi0.set_xdata(xdatai0)
        self.linesi0.set_ydata(ydatai0)
        self.linesi1.set_xdata(xdatai1)
        self.linesi1.set_ydata(ydatai1)
        self.linesi10.set_xdata(xdatai10)
        self.linesi10.set_ydata(ydatai10)
        self.linesi2.set_xdata(xdatai2)
        self.linesi2.set_ydata(ydatai2)


        self.lines.set_xdata(xdata)
        self.lines.set_ydata(ydata)
        self.lines1.set_xdata(xdata1)
        self.lines1.set_ydata(ydata1)

        #self.linesBirth.set_xdata(xdataBR)
        #self.linesBirth.set_ydata(ydataBR)
        #self.linesapples.set_xdata(AppleX)
        #self.linesapples.set_ydata(AppleY)

        #Need both of these in order to rescale
        self.ax.relim(visible_only=True)
        self.ax.autoscale_view()
        #self.ay.autoscale_view()
        #We need to draw *and* flush
        self.figure.set_size_inches(6,6)
        self.figure.savefig(ExpFolder + str(CurrentTime) + ".png")

        self.figure.canvas.draw()
        self.figure.canvas.flush_events()

    #Example
    def __call__(self):
        global CurrentTime, WAverageDistance, WGlobalNumberOfInteractionsPerHost
        if DisplayWindow == 1:
            self.on_launch()
        #xdata = [0 for ix in range (100)]
        #ydata = [0 for ix in range (100)]
        Start()
        for ix in range(Timepoints):
            CurrentTime = ix

            if ix == 3:
                SeedPatogen(10)

            if ix ==4:
                SeedTheExpriment()

            if ix > 10:
                MaintainThePathogen()

            MovementAndInfection()
            CalculateArea()
            Death()
            Replication()
            RenewMatrix()

            if DisplayWindow==1:
                X0 = (MaxAge == MaxAgeShort) * X
                Y0 = (MaxAge == MaxAgeShort) * Y
                X1 = (MaxAge == MaxAgeLong) * X
                Y1 = (MaxAge == MaxAgeLong) * Y

                A = np.zeros(PopSize)
                for p in range(1, PopSize):
                    for n in range(numberOfPathogens):
                        A[p] += InfectionStatus[p][n]

                X2 = (A == 1) * X
                Y2 = (A == 1) * Y
                X3 = (A == 2) * X
                Y3 = (A == 2) * Y
                X4 = (A == 3) * X
                Y4 = (A == 3) * Y
                X5 = (A == 4) * X
                Y5 = (A == 4) * Y

                self.on_running(X0, Y0, X1, Y1, X2, Y2, X3, Y3, X4, Y4, X5, Y5)

                if CurrentTime < 5000:
                    NoOfSLAnimals[CurrentTime] = (MaxAge == MaxAgeShort).sum()
                    NoOfLLAnimals[CurrentTime] = (MaxAge == MaxAgeLong).sum()
                    NoOfInfections[CurrentTime] = (InfectionStatus == 1).sum()

            if ix > 100 and ((MaxAge==MaxAgeShort).sum()==0 or (MaxAge==MaxAgeLong).sum()==0):
                if (MaxAge==MaxAgeLong).sum()==0:
                    ResultFIN = "1" #""Short_life_won"
                else:
                    ResultFIN = "0" #""Long_life_won"

                TLfileOut = WriteTimelineFile()
                Output = str(AREA_MODIFIER) + '\t' +str(SET_NUMBER) +'\t' + str(REPL) + '\t' + ResultFIN + '\t' + str(ix) +'\t' + str(Repulsion) + '\t'+ str(BirthRate) + '\t'+ str(MaxAgeShort) + '\t'+ str(MaxAgeLong) + '\t'+ str(Infectivity) + '\t'+ str(InfectionPenalty) +  '\t' + str(DensityOfSLAt300) + '\t' + str(TimeOfLLPeaking) + '\t' + str(PEAKNumberOfSL) + '\t' + str(PEAKNumberOfLL) + '\t' + str(PEAK_inf_proportionSL) + '\t' + str(PEAK_inf_proportionLL) + '\t'+ TLfileOut +'\n'

                inputfile = open(filenameX, 'a')
                inputfile.write(Output)
                inputfile.close()

                break

            #Output virus genotypes
            if (ix % 10 ==0):
                WriteTimelineFile()

            #print Area.min(), Area.max()

                #print Area.mean(), '\t', PopSize
            #print WAverageDistance, '\t', WNumberOfInteractions, '\t', WAverageDistance / WNumberOfInteractions,'\t', Animals.sum()
            #print WGlobalNumberOfInteractionsPerHost / PopSize , '\t', PopSize
            #print WGlobalNumberOfInteractionsPerHost / PopSize, '\t', PopSize
            #print ix, ':\t', PopSize - 1, '\t', (InfectionStatus == 1).sum() + (
            #        InfectionStatus == 2).sum(), '\t', LargeMapNumOfAnimals.max()  # LargeMapNumOfAnimals.max()
            #print PopSize

        #for i in range(1, PopSize):
        #    print X[i]/1000,'\t', Y[i]/1000, '\t->\t', LMX[i],'\t', LMY[i]

        #for ix in range(100):
        #    for iy in range(100):
        #        self.on_running(X[LargeMap[ix][iy][1]], Y[LargeMap[ix][iy][1]])
        #        print X[LargeMap[ix][iy][1]], '\t', Y[LargeMap[ix][iy][1]], "->", ix * 1000, iy * 1000

        #cProfile.run('re.compile("foo|bar")')
        #pr.disable()
        #s = StringIO.StringIO()
        #sortby = 'cumulative'
        #ps = pstats.Stats(pr, stream=s).sort_stats(sortby)
        #ps.print_stats()
        #print s.getvalue()

        return X, Y

d = DynamicUpdate()
d()

TimelineFile.close()
#GenotypesFile.close()