##import matplotlib.pyplot as plt
##from matplotlib import colors
import numpy as np
import math
import random
#import cProfile
#import re
import sys
import os

DisplayWindow = 0

if (DisplayWindow == 1):
    ExpFolder = "C:/DATA/Ageing/Caviar/FIG_S1/1/"
    REPL = 1
    SET_NUMBER = 1
    Param = "4.08290863e+11"
    AGEParam = str(Param) #408290863037
    #AGEAverage = 30.0
    BETA = 10

else:
    ExpFolder = '/andino/hpse1/home/plidsky/Ageing/Caviar/FIG_S1/'
    #ExpFolder = '/home/users/plidsky/FIG1HM/'
    REPL = int(sys.argv[1])
    SET_NUMBER = int(sys.argv[2])

    AGEParam = int(sys.argv[3])
    BETA = int(sys.argv[4])
    #param_modifier = np.zeros(10, dtype=float)
    #for index in range(3, 5):
    #    param_modifier[index - 3] = 1.0  + 0.5 * (float(int(sys.argv[index])) - 2.0)

TimelineFileName  = ExpFolder + "1/cav_Fig1" + str(SET_NUMBER)+ "_replicate_" + str(REPL) +".txt"
TimelineFile = open(TimelineFileName, 'w')

filenameX = ExpFolder + "Summary2_Fig1.txt"

if os.path.isfile(filenameX) == False:
    inputfile = open(filenameX, 'w')
    inputfile.write('SetNumber\tReplica\tOUTCOME\tTotalTime\t0-Repulsion\t1-BirthRate\t2-Gompertz_Alpha\tGompertz_Beta\tAverageAge\t3-Infectivity\t4-InfectionPenalty\tDensityOfSLAt300\tTimeOfLLPeaking\tPEAKNumberOfSL\tPEAKNumberOfLL\tPEAK_inf_proportionSL\tPEAK_inf_proportionLL\tFINTime\tFINTotalNumberOfAnimals\tFINNumberOfSL\tFINSLInfected\tFINNumberOfLL\tFINLLInfected\tFINSL_inf_proportion\tFINLL_inf_proportion\n')
    inputfile.close()

DensityOfSLAt300 = 0
TimeOfLLPeaking = 0
PEAKNumberOfSL = 0
PEAKNumberOfLL = 0
PEAK_inf_proportionSL = 0
PEAK_inf_proportionLL = 0

random.seed()
##plt.ion()

Timepoints = 100000
CurrentTime = 0

#Host population
MaxPopSize = 5000 #50000
PopSize = 5000
#MapSize = 10000.0
MapXSize = 10000.0
MapYSize = 10000.0
NumberOfSubdivisions = 100.0
MapConv = math.sqrt(MapXSize * MapYSize) / NumberOfSubdivisions
SubdivXSize = MapXSize / MapConv + 1
SubdivYSize = MapYSize / MapConv + 1

########
#WAverageDistance = 0.0
#WNumberOfInteractions = 0.0
#WGlobalNumberOfInteractionsPerHost = 0.0

#Host movement
#TurningProbability = 0.01
MaxSpeed = 100.0
FrictionCoeff = 0.000

MaxRadius = 400.0
MaxRadiusSq = MaxRadius**2.0

InfectionRadius = 200.0
InfectionRadiusSq = InfectionRadius**2.0

Range = InfectionRadius / 2.0 #This is about area each individual takes
RangeSq = Range**2.0
MaxArea = math.pi * RangeSq / 2.0

#Repulsion = 20000  * param_modifier[0] ################0
Repulsion = 0
#RepulsionWall = 1000

BirthRate = 0.4  #* param_modifier[1] #################1
ReplicationFreq = 100.0 / BirthRate
#MaxAgeShort = AGEParam  #* param_modifier[2] #################2
Gompertz_Alpha = 0.000001
Gompertz_Beta = float(AGEParam) / 1000000000000.0
#print Gompertz_Beta

MaxAgeLong = 180
#Virus
Infectivity = float(BETA) / 10000.0#  * param_modifier[3] ##############3
InfectionPenalty = 0.00#  * param_modifier[4] ##########4

MaxAnimalsInSubdivision = 10000

NumberOftimepointsInSet = 500
Set1 = np.zeros(NumberOftimepointsInSet, dtype=float)
############################################################

TimelineFile.write('SetNumber\tReplica\t0-Repulsion\tMaxSpeed\tFrictionCoeff\tMaxRadius\tInfectionRadius\t1-BirthRate\t2-Gompertz_Alpha\tGompertz_Beta\tMaxAgeLong\t3-Infectivity\t4-InfectionPenalty\n')
Output = str(SET_NUMBER) + '\t' + str(REPL) + '\t' + str(Repulsion) +'\t'+ str(MaxSpeed) + '\t' + str(FrictionCoeff) + '\t' + str(MaxRadius) + '\t' + str(InfectionRadius) + '\t' + str(BirthRate) + '\t' + str(Gompertz_Alpha) + '\t'  + str(Gompertz_Beta) +'\t' + str(MaxAgeLong) + '\t' + str(Infectivity) + '\t' + str(InfectionPenalty) + '\n'
TimelineFile.write(Output)
TimelineFile.write('Time\tTotalNumberOfAnimals\tNumberOfSL\tSLInfected\tNumberOfLL\tLLInfected\tSL_inf_proportion\tLL_inf_proportion\n')
TimelineFile.close()
TimelineFile = open(TimelineFileName, 'a')
############################################################

Animals = np.zeros(PopSize)
Age = np.zeros(PopSize)
ReplicationScore = np.zeros(PopSize)
Fitness = np.zeros(PopSize)
#AreaBelonging = np.zeros(PopSize)
X = np.zeros(PopSize)
Y = np.zeros(PopSize)
Area = np.zeros(PopSize)
residueX = np.zeros(PopSize)
residueY = np.zeros(PopSize)
speedX = np.zeros(PopSize)
speedY = np.zeros(PopSize)
MaxAge = np.zeros(PopSize)
InfectionStatus = np.zeros(PopSize, dtype=int) #
#InfectionID = np.zeros(PopSize, dtype=int) #ID
#InfectionPOT = np.zeros(PopSize, dtype=float) #POT
LMX=np.zeros(PopSize, dtype=int)
LMY=np.zeros(PopSize, dtype=int)
#Shapes = [[Segment for x in xrange(12)] for y in xrange(MaxPopSize)]

ShuffledIndexes = np.zeros(PopSize)
SummOfAllInteraction = np.zeros(PopSize)

VirusGenotypes = np.zeros(100, dtype=int)

#IsOnApple = np.zeros(PopSize, dtype=int)
#TargrgetedToApple = np.zeros(PopSize, dtype=int)
#DistanceToTargetedToApple = np.zeros(PopSize) + 10000000000000
#RelationToApples = np.zeros(PopSize, dtype=int)

LargeMap = np.zeros((int(SubdivXSize+1), int(SubdivYSize+1), MaxAnimalsInSubdivision), dtype=int)
LargeMapNumOfAnimals = np.zeros((int(SubdivXSize+1 ), int(SubdivYSize +1)))

#Output
AgeBins = np.zeros(MaxAgeLong, dtype=int)
InfectedAgeBins = np.zeros(MaxAgeLong, dtype=int)

#Mutations
#MutationProbability = 0.0001
#NumberOfStrains = 2


def Start():
    #for index in range(1, 3):
    #PopSize = 1000
    #
    #for index in range(1, PopSize/2):
    global PopSize

    for index in range(1, PopSize):
        Animals[index] = 1
        Fitness[index] = 100.0
        ReplicationScore[index] = random.random() * ReplicationFreq

        X[index] = random.random() * float(MapXSize)
        Y[index] = random.random() * float(MapYSize)

        speedX[index] = MaxSpeed - random.random() * MaxSpeed * 2.0
        speedY[index] = MaxSpeed - random.random() * MaxSpeed * 2.0

        #MaxAge[index] = MaxAgeShort
        MaxAgeX = 300
        Age[index] = int(MaxAgeX * 1.1 * random.random())
        rewind = True
        while(rewind==True):
            rewind=False
            for j in range(1 , int(Age[index])):
                if random.random() < Gompertz_Alpha * math.exp(float(j) * Gompertz_Beta):
                    Age[index] = int(MaxAgeX * random.random())
                    rewind = True
                    break

        InfectionStatus[index] = 0
        #InfectionPOT[index] = 0
        #InfectionID[index] = 0
        Area[index] = 0
        AddAnimalToMatrix(index)

    #return
    #long lifespans

def SeedTheExpriment():

    N = (InfectionStatus==1).sum()
    if N < 10:
        for i in range(10-N):
            index =  int(random.random() * PopSize-2)
            InfectionStatus[index+1]=1

def ShuffleIndexes():
    global ShuffledIndexes
    ShuffledIndexes = np.zeros(PopSize)
    for i in range(1, PopSize):
        ShuffledIndexes[i] = int(i)
    random.shuffle(ShuffledIndexes)
    ShuffledIndexes = np.append([0], ShuffledIndexes)

def MovementAndInfection():
    global SummOfAllInteraction, WAverageDistance, WNumberOfInteractions, WGlobalNumberOfInteractionsPerHost, SubdivXSize, MaxRadiusSq
    ShuffleIndexes()

    #Calculate range of interactions
    wrange = int(round(MaxRadius / MapConv)) + 1

    SummOfAllInteraction = np.zeros(PopSize)
    ######
    #WAverageDistance = 0.0
    #WNumberOfInteractions = 0.0
    #WGlobalNumberOfInteractionsPerHost = 0.0
    #--------------------
    for i in range(1, PopSize):
        #Calculate working box
        top = LMY[i] + wrange
        bottom = LMY[i] - wrange
        left = LMX[i] - wrange
        right = LMX[i] + wrange

        ####
        #WNumberOfInteractionsPerHost = 0

        #if top >= SubdivYSize: top = int(SubdivYSize-1)
        #if bottom < 0:
        #    bottom = 0

        NewSpeedX = 0
        NewSpeedY = 0

        for lxindex in range(left, right+1):
            if lxindex < 0:
                ExcessX = SubdivXSize + 1
                RelationToBorderX = -1
            elif lxindex > SubdivXSize:
                ExcessX = - SubdivXSize
                RelationToBorderX = 1
                #Excess = -lxindex
            else:
                ExcessX = 0
                RelationToBorderX = 0

            for lyindex in range(bottom, top + 1):
                if lyindex < 0:
                    ExcessY = SubdivYSize + 1
                    RelationToBorderY = -1
                elif lyindex > SubdivYSize:
                    ExcessY = - SubdivYSize
                    RelationToBorderY = 1
                    # Excess = -lxindex
                else:
                    ExcessY = 0
                    RelationToBorderY = 0

                index = 1
                while True:
                    a = LargeMap[lxindex + int(ExcessX)][lyindex+ int(ExcessY)][index]
                    if a == 0: break

                    distanceSq = float((X[a]+ RelationToBorderX * MapXSize - X[i])**2 + (Y[a]+ RelationToBorderY * MapYSize - Y[i])**2)
                    #distanceSq = distance**2.0
                    distanceCube = distanceSq**1.5# math.sqrt(distanceSq)
                    #print distanceSq
                    if (distanceSq < RangeSq*4):
                        ##############
                        #WAverageDistance += math.sqrt(distanceSq)
                        #WNumberOfInteractions+=1
                        #WNumberOfInteractionsPerHost+=1

                        AngleAlpha = math.acos(math.sqrt(distanceSq / RangeSq/ 4.0))
                        #print AngleAlpha, AngleAlpha - math.sin(AngleAlpha)
                        SummOfAllInteraction[i] += AngleAlpha - math.sin(AngleAlpha)
                        #print AngleAlpha - math.sin(AngleAlpha)

                    #if (distanceCube==0):
                    #    distanceCube = 1.0
                    #NewSpeedX += Repulsion * (X[i]-(X[a] + RelationToBorderX * MapXSize)) / (distanceCube)
                    #NewSpeedY += Repulsion * (Y[i]-(Y[a] + RelationToBorderY * MapYSize)) / (distanceCube)

                    if InfectionStatus[i] == 1 and InfectionStatus[a] == 0 and random.random() < Infectivity * (InfectionRadiusSq - distanceSq) /(InfectionRadiusSq):
                        InfectionStatus[a] = 1

                    index+=1

        if random.random() < 0.1:
            speedX[i] = MaxSpeed - random.random() * MaxSpeed * 2.0
            speedY[i] = MaxSpeed - random.random() * MaxSpeed * 2.0

            TotalSpeed = (speedX[i]*speedX[i] + speedY[i]*speedY[i]) / (MaxSpeed * MaxSpeed)
            if TotalSpeed > 1:
                speedX[i] = speedX[i] / math.sqrt(TotalSpeed)
                speedY[i] = speedY[i] / math.sqrt(TotalSpeed)

    for j in range(1, PopSize):
        index = int(ShuffledIndexes[j])
        #Movement itself
        X[index] += speedX[index]
        Y[index] += speedY[index]

        if X[index] > MapXSize:
            X[index] = X[index] - MapXSize
        elif X[index] < 0:
            X[index] = MapXSize + X[index]

        if Y[index] > MapYSize:
            Y[index] = Y[index] - MapYSize
        elif Y[index] < 0:
            Y[index] = MapYSize + Y[index]


        ##########
        #if WNumberOfInteractions > 0:
        #    WAverageDistance = WAverageDistance / WNumberOfInteractions


            #if random.random() < TurningProbability * turncoeff:
        #    speedX[index] = MaxSpeed - random.random() * MaxSpeed * 2.0
        #    speedY[index] = MaxSpeed - random.random() * MaxSpeed * 2.0

def AddAnimal(newX, newY, MaxAgeLimit):
    global Area, Radius,MaxAge, Animals, ReplicationScore, Fitness,AreaBelonging, X, Y, residueX, residueY, speedX, speedY, PopSize, Age, InfectionStatus, LMX, LMY, DistanceToTargetedToApple, RelationToApples, InfectionPOT, InfectionID
    if PopSize > MaxPopSize: return
    Animals = np.append(Animals,[1])
    ReplicationScore = np.append(ReplicationScore, [0])
    Fitness = np.append(Fitness, [100])
    X = np.append(X, [newX])
    Y = np.append(Y, [newY])
    residueX = np.append(residueX, [0])
    residueY = np.append(residueY, [0])
    speedX = np.append(speedX, [MaxSpeed - random.random() * MaxSpeed * 2.0])
    speedY = np.append(speedY, [MaxSpeed - random.random() * MaxSpeed * 2.0])
    #AreaBelonging = np.append(AreaBelonging, [math.pi * Range ** 2 / 2])
    Age = np.append(Age, [0])
    MaxAge = np.append(MaxAge, [MaxAgeLimit])
    InfectionStatus = np.append(InfectionStatus, [0])
    LMX = np.append(LMX,[0])
    LMY = np.append(LMY, [0])
    #InfectionPOT = np.append(InfectionPOT, [0])
    #InfectionID = np.append(InfectionID, [0])
    #IsOnApple = np.append(IsOnApple, [0])
    #TargrgetedToApple = np.append(TargrgetedToApple, [0])
    #DistanceToTargetedToApple = np.append(DistanceToTargetedToApple, [10000000000000])
    #RelationToApples = np.append(RelationToApples, [0])
    Area = np.append(Area, [math.pi * RangeSq / 2])

    AddAnimalToMatrix(PopSize)
    PopSize+=1

def DeleteAnimal(indexToDel):
    global Area, Radius, Animals, ReplicationScore, Fitness,AreaBelonging, X, Y, residueX, residueY, speedX, speedY, PopSize, Age, MaxAge, InfectionStatus, LMX, LMY, DistanceToTargetedToApple, RelationToApples, InfectionPOT, InfectionID
    #DeleteAnimalFromMatrix(indexToDel)
    Animals = np.delete(Animals, indexToDel)
    ReplicationScore = np.delete(ReplicationScore, indexToDel)
    Fitness = np.delete(Fitness, indexToDel)
    X = np.delete(X, indexToDel)
    Y = np.delete(Y, indexToDel)
    residueX = np.delete(residueX, indexToDel)
    residueY = np.delete(residueY, indexToDel)
    speedX = np.delete(speedX, indexToDel)
    speedY = np.delete(speedY, indexToDel)
    Age = np.delete(Age, indexToDel)
    MaxAge = np.delete(MaxAge, indexToDel)
    InfectionStatus = np.delete(InfectionStatus, indexToDel)
    #InfectionPOT = np.delete(InfectionPOT, indexToDel)
    #InfectionID = np.delete(InfectionID, indexToDel)
    LMX = np.delete(LMX, indexToDel)
    LMY = np.delete(LMY, indexToDel)
    #RelationToApples = np.delete(RelationToApples, indexToDel)
    #DistanceToTargetedToApple = np.delete(DistanceToTargetedToApple, indexToDel)
    Area = np.delete(Area, indexToDel)

    PopSize -= 1

def Replication():
    global X, Y
    ShuffleIndexes()
    for j in range(1, PopSize):
        index  = int(ShuffledIndexes[j])
        ReplicationScore[index] += Fitness[index]
        if (ReplicationScore[index] > ReplicationFreq) and (PopSize <= MaxPopSize):
            ReplicationScore[index] = 0
            deltaX = 1.0 - 2.0 * random.random()
            deltaY = 1.0 - 2.0 * random.random()
            AddAnimal(X[index] + deltaX, Y[index] + deltaY, MaxAge[index])
            X[index] = X[index] - deltaX
            Y[index] = Y[index] - deltaY

def Death():
    global Animals, PopSize
    index = 1
    while index < PopSize:
        Age[index] += 1
        if random.random() < Gompertz_Alpha * math.exp(float(Age[index]) * Gompertz_Beta):
            Animals[index] = 0
            DeleteAnimal(index)
        else:
            index+=1

def AddAnimalToMatrix(i):
    global LargeMap, LargeMapNumOfAnimals, LMX, LMY
    #print LargeMapNumOfAnimals.size
    LMX[i]=int(round(X[i]/MapConv))
    LMY[i]=int(round(Y[i]/MapConv))
    LargeMapNumOfAnimals[LMX[i]][LMY[i]] +=1
    #Size =
    LargeMap[LMX[i]][LMY[i]][int(LargeMapNumOfAnimals[LMX[i]][LMY[i]])] = i

def CalculateSpeed():
    x=0

def RenewMatrix():
    global LargeMap, LargeMapNumOfAnimals
    LargeMap = np.zeros((int(SubdivXSize + 1), int(SubdivYSize + 1), MaxAnimalsInSubdivision), dtype=int)
    LargeMapNumOfAnimals = np.zeros((int(SubdivXSize + 1), int(SubdivYSize + 1)))
    #LargeMap = np.zeros((int(NumberOfSubdivisions + 1), int(NumberOfSubdivisions + 1), MaxAnimalsInSubdivision), dtype=int)
    #LargeMapNumOfAnimals = np.zeros((int(NumberOfSubdivisions + 1), int(NumberOfSubdivisions + 1)))

    for i in range(1, PopSize):
        AddAnimalToMatrix(i)

def CalculateArea():
    global Fitness, Area, RangeSq, MaxArea
    for i in range(1, PopSize):
        #Area[i] = (math.pi - SummOfAllInteraction[i]) * RangeSq / 2.0
        #if Area[i]<0: Area[i]=0

        Fitness[i] = 100 #* (1 - InfectionPenalty * InfectionStatus[i]) * (Area[i] - MaxArea / 2.0) / MaxArea * 2.0
        #if Fitness[i]<0: Fitness[i]=0
    #print "SuumOfAllInteractions=" + str(np.sum(SummOfAllInteraction)/PopSize)
    #print PopSize, np.sum(Area)/ PopSize, np.sum(SummOfAllInteraction)/PopSize

def WriteTimelineFile():
    ShortLivedInfected = 0
    LongLivedInfected = 0
    global DensityOfSLAt300, TimeOfLLPeaking, PEAKNumberOfSL, PEAKNumberOfLL, PEAK_inf_proportionSL, PEAK_inf_proportionLL, CurrentTime

    for i in range(PopSize):
        if (InfectionStatus[i] == 1):
            if (MaxAge[i] == MaxAgeLong):
                LongLivedInfected += 1
            else:
                ShortLivedInfected += 1

    ShortTotal = Animals.sum()
    LongTotal = (MaxAge == MaxAgeLong).sum()
    if LongTotal > 0:
        LongIPercent = float(LongLivedInfected) / LongTotal
    else:
        LongIPercent = 0
    if ShortTotal > 0:
        ShortIPercent = float(ShortLivedInfected) / ShortTotal
    else:
        ShortIPercent = 0

    Output = str(CurrentTime) + '\t' + str(PopSize - 1) + '\t ' + str(ShortTotal) + '\t' + str(ShortLivedInfected) + '\t' + str(
        LongTotal) + '\t' + str(LongLivedInfected) + '\t' + str(ShortIPercent) + '\t' + str(LongIPercent) + '\t'+ str(Age.mean())
    # ,'\t', float((InfectionStatus == 1).sum()+(InfectionStatus == 2).sum()) / (PopSize), '\t', LargeMapNumOfAnimals.max() #LargeMapNumOfAnimals.max()
    if PEAKNumberOfLL < LongTotal:
        TimeOfLLPeaking = CurrentTime
        PEAKNumberOfSL = ShortTotal
        PEAKNumberOfLL = LongTotal
        PEAK_inf_proportionSL = ShortIPercent
        PEAK_inf_proportionLL = LongIPercent

    if (CurrentTime == 300):
        DensityOfSLAt300 = ShortTotal

    if DisplayWindow==1:
        print Output

    TimelineFile.write(Output + '\n')

    return Output

class DynamicUpdate():
    #Suppose we know the x range
    min_x = 0
    max_x = MapXSize
    min_y = 0
    max_y = MapYSize
    tPlt = 0
    axes = 0
    global ColorMapUsed, HistogrammUpperLimit, HistColor, binning
    ColorMapUsed = 'summer'
    binning = 1
    HistogrammUpperLimit = 135 #int(MaxAgeShort)

    HistColor = np.zeros((HistogrammUpperLimit, 4))


    # def on_launch(self):
    #     global tPlot, axes, HistColor, HistogrammUpperLimit, ColorMapUsed
    #     #Set up plot
    #     tPlot, axes = plt.subplots(nrows=2, ncols=1, sharex=False, sharey=False, gridspec_kw={'height_ratios': [3.56, 1]})#, tight_layout=True)
    #     #axes[0].axis('off')
    #     #tPlot.set_size_inches(6, 8.3)
    #     cmap = plt.cm.get_cmap(ColorMapUsed)
    #     for i in range (1, HistogrammUpperLimit / binning):
    #         HistColor[i] = cmap(1.0 - (1.0 * float(i) / float(HistogrammUpperLimit/binning) ))
    #
    # def on_running(self, xdata, ydata, age, xdata1, ydata1, xdata2, ydata2, xdataBR, ydataBR):
    #     global HistColor, binning
    #     tPlot.set_size_inches(3, 4.15)
    #     #tPlot.clf()
    #     axes[0].cla()
    #     axes[0].set_title("Lifespan=" + str(MaxAgeShort))
    #     lines2 = axes[0].scatter(xdata2, ydata2, s=30, c='black', alpha=1, linewidths=0)
    #     lines2 = axes[0].scatter(xdata2, ydata2, s=3, c='white', alpha=1)
    #     lines1 = axes[0].scatter(xdata, ydata, s=4, c=age, cmap=ColorMapUsed, alpha=0.2, vmin=0, vmax=HistogrammUpperLimit)
    #     dummy = axes[0].scatter([0], [0], s=45, linewidths=0, c='white', alpha=1)
    #     axes[0].xaxis.set_visible(False)
    #     axes[0].yaxis.set_visible(False)
    #     #axes[0].show()
    #
    #     axes[1].cla()
    #     N, bins, patches = axes[1].hist(Age,  bins = HistogrammUpperLimit / binning, range = (1, HistogrammUpperLimit  ), alpha=0.5)
    #     #print N
    #     fracs = np.asarray(range(0, HistogrammUpperLimit / binning))
    #     norm = colors.Normalize(fracs.min(), fracs.max())
    #     cmap = plt.cm.get_cmap(ColorMapUsed)
    #     for thisfrac, thispatch in zip(fracs, patches):
    #         color = cmap(norm(thisfrac))
    #         thispatch.set_facecolor(color)
    #     axes[1].set_ylim([0, 150])
    #     axes[1].set_xlabel("ages")
    #     #axes[1].set_ylabel("number")
    #     axes[1].hist(((InfectionStatus==1) * Age), bins = HistogrammUpperLimit / binning, range = (1, HistogrammUpperLimit), color='black', alpha=1)
    #
    #     tPlot.savefig(ExpFolder + str(CurrentTime) + ".png", bbox_inches='tight')
    #     tPlot.canvas.flush_events()


    #Example
    def __call__(self):
        global CurrentTime, WAverageDistance, WGlobalNumberOfInteractionsPerHost, AgeBins, InfectedAgeBins, Set1, InfectionStatus, PopSize
        #if DisplayWindow == 1:
        #    self.on_launch()
        #xdata = [0 for ix in range (100)]
        #ydata = [0 for ix in range (100)]
        Start()
        for ix in range(Timepoints):
            CurrentTime = ix

            MovementAndInfection()
            CalculateArea()
            Death()
            Replication()
            RenewMatrix()

            if (ix > 10):
                SeedTheExpriment()

            if ix > 1000 and Set1[0:NumberOftimepointsInSet / 2].mean() >= Set1[NumberOftimepointsInSet / 2: NumberOftimepointsInSet].mean():

                TLfileOut = WriteTimelineFile()
                Output = str(SET_NUMBER) + '\t' + str(REPL) + '\t' + str(Set1.mean()) + '\t' + str(ix) +'\t' + str(Repulsion) + '\t'+ str(BirthRate) + '\t' + str(Gompertz_Alpha) + '\t'  + str(Gompertz_Beta) +'\t'+ str(Age.mean())+'\t'+ '\t'+ str(MaxAgeLong) + '\t'+ str(Infectivity) + '\t'+ str(InfectionPenalty) +  '\t' + str(DensityOfSLAt300) + '\t' + str(TimeOfLLPeaking) + '\t' + str(PEAKNumberOfSL) + '\t' + str(PEAKNumberOfLL) + '\t' + str(PEAK_inf_proportionSL) + '\t' + str(PEAK_inf_proportionLL) + '\t'+ TLfileOut +'\n'

                inputfile = open(filenameX, 'a')
                inputfile.write(Output)
                inputfile.close()

                break

            Set1 = np.append(Set1[1:NumberOftimepointsInSet-1], [1.0 * (InfectionStatus.sum() / float(PopSize))])
            #Set3[SetCounter] = 1.0 * (InfectionStatus.sum() / float(PopSize))
            #print 1.0 * (InfectionStatus.sum() / float(PopSize))
            #Output virus genotypes
            if (ix % 10 ==0):
                WriteTimelineFile()

            #print Area.mean(), '\t', PopSize
            #print WAverageDistance, '\t', WNumberOfInteractions, '\t', WAverageDistance / WNumberOfInteractions,'\t', Animals.sum()
            #print WGlobalNumberOfInteractionsPerHost / PopSize , '\t', PopSize
            #print WGlobalNumberOfInteractionsPerHost / PopSize, '\t', PopSize
            #print ix, ':\t', PopSize - 1, '\t', (InfectionStatus == 1).sum() + (
            #        InfectionStatus == 2).sum(), '\t', LargeMapNumOfAnimals.max()  # LargeMapNumOfAnimals.max()
            #print PopSize

        #for i in range(1, PopSize):
        #    print X[i]/1000,'\t', Y[i]/1000, '\t->\t', LMX[i],'\t', LMY[i]

        #for ix in range(100):
        #    for iy in range(100):
        #        self.on_running(X[LargeMap[ix][iy][1]], Y[LargeMap[ix][iy][1]])
        #        print X[LargeMap[ix][iy][1]], '\t', Y[LargeMap[ix][iy][1]], "->", ix * 1000, iy * 1000

        #cProfile.run('re.compile("foo|bar")')
        #pr.disable()
        #s = StringIO.StringIO()
        #sortby = 'cumulative'
        #ps = pstats.Stats(pr, stream=s).sort_stats(sortby)
        #ps.print_stats()
        #print s.getvalue()

        return X, Y

d = DynamicUpdate()
d()

TimelineFile.close()
#GenotypesFile.close()