import numpy as np
import scipy.integrate as spi
import math
import matplotlib.pyplot as plt
import random
import seaborn as sns; sns.set()

ExpFolder = "C:/DATA/Ageing/Caviar/FIG2HM/"#Analytics_Adaptation.txt"

Emulation = 0

#Teta_n = 3.0
# #Default = 0.5
#B = 10.0 #Default = 5
#P = 1.0 #Default=1.0
N = 5000 #

Start_LL_percent = 50
Start_Infected_percent = 1

v0 = np.zeros(11)
v0[0] = 4990.0
v0[1] = 0.0
for i in range(2, 11):
    v0[i]=0.0
v0[10] = 0.0

simulation_time = 50000
number_datapoints = 5000
t = np.linspace(0., simulation_time, number_datapoints) #timepoints, timepoints)
StStatePart = 5

number = 0
Asl_min = 1
Asl_max = 1000
Asl_step = 2

Asl_range = range(Asl_min, Asl_max, Asl_step)
Asl_size = (Asl_max - Asl_min) / Asl_step

beta = 0
beta_min = 5
beta_max = 1005
beta_step = 5
beta_range = range(beta_min, beta_max, beta_step)
beta_size = (beta_max - beta_min)/ beta_step

Asl = 90.0
All = 180.0

Bbasic = 0.4 #float(B) / 100.0
#Teta_n = float(Teta_n)

Descriptor = "Adaptation2_feasibility"
TimelineFileName  = ExpFolder + "cav_An_" + Descriptor + "2.txt"

def CalculateAreaModifier(subtype_Area):
    global SigmaMax
    print float(1.0 - (SigmaMax - subtype_Area)/ SigmaMax)
    return float(1.0 - (SigmaMax - subtype_Area)/ SigmaMax)


def f(v, t0, ):
    global Asl, All, N, P, beta, Teta_n, nju, SigmaWhole, SigmaMax, Bbasic, v0
    dN = np.zeros(11, dtype=float)

    TotalPopulation = 0.0
    for i in range(11):
        TotalPopulation += v[i]

    SummOfInfections = 0.0
    #if v[1]<0 and v0[10] == 0.0:
    #    dN[1] = 10.0 - v[1]
    #    SummOfInfections += dN[1]

    for i in range(2, 11):
        dN[i] = v[i-1] * v[0] * beta / 10.0 / N - v[i] / Asl
        SummOfInfections += v[i-1] * v[0] * beta / 10.0 / N

    if v0[10]> 0.0:
        dN[10] += v[10] * v[0] * beta / N - v[10] / Asl
        SummOfInfections += v[10] * v[0] * beta / N

    dN[0] = TotalPopulation * (N**5 - TotalPopulation**5) / N**5 * Bbasic - SummOfInfections - v[0] / Asl

    return dN #np.r_[Ssl_new, Sll_new, Isl_new, Ill_new]

def test(Asl_index):
    global Asl, beta, v0
    Asl = float(Asl_index)
    #beta = float(beta_index) / 1000.0

    v = spi.odeint(f, v0, t)

    Result = 0
    time = number_datapoints
    for i in range(number_datapoints/2, number_datapoints):
        if v[i][10] > 1.0:
            Result = 1

    return Result

def CalculateBorderAge():
    #global beta, v0
    Asl_top = float(Asl_max)
    Asl_bottom = float(Asl_min)

    if test(Asl_top) == 0:
        Value = Asl_top + 1
    else:
        GoOn = True
        while GoOn == True:
            Asl_middle = float(Asl_top + Asl_bottom) / 2.0
            if test(Asl_middle) == 1:
                Asl_top = Asl_middle
            else:
                Asl_bottom = Asl_middle

            if (Asl_top - Asl_bottom) < Asl_step:
                GoOn = False
                Value = float(Asl_top + Asl_bottom) / 2.0
    return Value

######################################################
######################################################
######################################################

if Emulation==0:

    TimelineFile = open(TimelineFileName, 'w')

    TimelineFile.write("Number\tAge\tbeta\tBirthRate\n")

    for beta_index in beta_range: # range(5, 505, 50):
        #for Teta_n_index in [Teta_n]:#range(10, 20, 2):
            Value = 0
            beta = float(beta_index) / 1000.0

            v0[0] = 4990.0
            v0[1] = 10.0
            v0[10] = 0.0
            Adapt = CalculateBorderAge()

            v0[0] = 4998.0
            v0[1] = 0.0
            v0[10] = 2.0
            Feas = CalculateBorderAge()

            Out = str(number)+ '\t' + str(Bbasic)+ '\t' + str(beta)+ '\t' + str(Feas)+ '\t' + str(Adapt)
            TimelineFile.write(Out + '\n')
            print Out
            number += 1

    TimelineFile.close()

beta = 0.035
Asl = 35

v = spi.odeint(f, v0, t)

tPlot, axes = plt.subplots(
        nrows=1, ncols=1, sharex=True, sharey=False,
        gridspec_kw={'height_ratios':[1]}
        )

fig, ax = plt.subplots(1, 1, figsize=(8, 4))

ax.plot(t, v[:,0], '-', c = 'y', alpha=1)
ax.plot(t, v[:,10], '-', c = 'r', alpha=1)

#ax.plot(t, v[:,2], '.-', c = 'y', alpha=0.6)
#ax.plot(t, v[:, 3], '.-', c = 'r', alpha=0.6)

#ax.plot(t, v[:,2], '-', c = 'b')
#ax.plot(t, v[:, 3], '-', c = 'b')
#ax.set_xlim(0, 25)
#ax.set_ylim(0, 10000)
#print v[timepoints-1][0] , v[timepoints-1][1] ,v[timepoints-1][2] ,v[timepoints-1][3]
#print v[:, 1].min()

plt.show()

exit()

data = np.zeros((beta_size , Asl_size ))
data1 = np.zeros((beta_size , Asl_size))

data = np.zeros((Asl_size, beta_size ))
data1 = np.zeros((Asl_size, beta_size ))

fileInPut = open(TimelineFileName, 'r')

lines = fileInPut.readline()
for lines in fileInPut:
    #pass
    #if lines.__len__() > 1:
    #print lines
    lines=lines.split()

    number = 0
    for Asl_index in range(Asl_size):  # range(10, 180, 40):
        for beta_index in range(beta_size):  # range(5, 505, 50):
            if int(lines[0])==number:
                #result = 0
                data[Asl_size - 1 - Asl_index][beta_index] = int(float(lines[2]))
                data1[Asl_size - 1 - Asl_index][beta_index] = int(float(lines[3])) #math.log(Ratio, 10)

            number += 1
#data1 = np.random.rand(beta_range.__sizeof__() , Asl_range.__sizeof__() )
#print data1
#print data

Xlabels = ["" for i in range(beta_size)]
Ylabels = ["" for i in range(Asl_size)]

#n=0
for i in range(0, beta_size, int(beta_size/10)):
    Xlabels[i] = float(beta_range[i]) / 1000.0
    #n+=1

#n=0
for i in range(0, Asl_size, int(Asl_size/10)):
    Ylabels[Asl_size-i-1] = Asl_range[i]
    #n += 1
#ax = sns.heatmap(data)
Xlabels = Xlabels[0 : beta_size/2]
axes = sns.heatmap(data[:, 0:beta_size / 2], xticklabels=Xlabels, yticklabels=Ylabels, vmin=0, vmax=1, cmap="viridis")
tPlot.savefig(ExpFolder + "Outcome_" + Descriptor + ".png", bbox_inches='tight')
tPlot.clear()

axes = sns.heatmap(data[:, 0:beta_size / 2], xticklabels=Xlabels, yticklabels=Ylabels, vmin=0, vmax=1, cmap="jet")
tPlot.savefig(ExpFolder + "Time_" + Descriptor + ".png", bbox_inches='tight')
tPlot.clear()
